with text_io, calendar; use text_io, calendar;

procedure tasking is
  interval        : constant duration := 1.0;
  total_intervals : constant positive := 9;
  start_time      : constant time := clock;
  quitting_time   : constant time := start_time +
                                             total_intervals*interval;
  next_time       : time := start_time;
  start_time_dd   : Day_Duration;
  yn			  :	Year_Number;
  mn			  :	Month_Number;
  dn 			  :	Day_Number;
      
  function PutMyTime return STRING is
    dd			  : Day_Duration;
  begin
    split(clock,yn,mn,dn,dd);
    return Duration'Image(dd - start_time_dd);
  end;
                                                 
  task type tick is
    ENTRY IDENTIFY(TASK_NUMBER : IN NATURAL);
    entry shutdown;
  end tick;
  task body tick is
    quit : boolean := false;
    foo  : natural;
  begin
    while not quit loop
      select
        ACCEPT IDENTIFY(TASK_NUMBER : IN NATURAL) DO
          PUT_LINE("Task number " & INTEGER'IMAGE(TASK_NUMBER) &
               " is starting at " & PutMyTime);
          foo := TASK_NUMBER;     
        END IDENTIFY;   
		put_line("/ Start of task " & INTEGER'IMAGE(foo) & " at " & PutMyTime);
        delay 0.5;    
        put_line("\ End of task " & INTEGER'IMAGE(foo) & " at " & PutMyTime);
      or
        accept shutdown;
        quit := true;
      end select;
    end loop;
  end tick;

  T               : ARRAY(1 .. 3) OF TICK;
  PERIOD          : CONSTANT ARRAY(T'RANGE) OF POSITIVE := (2, 3, 4);
  TIMER           : ARRAY(T'RANGE) OF NATURAL := (OTHERS => 0);
  
begin
  split(start_time,yn,mn,dn,start_time_dd);  
  while next_time < quitting_time loop
    put_line("----------- Main LOOP starts at " & PutMyTime);  
    FOR I IN T'RANGE LOOP
      IF TIMER(I) = 0 THEN
        T(I).IDENTIFY(I);
        TIMER(I) := PERIOD(I);
      END IF;
      TIMER(I) := TIMER(I) - 1;
    END LOOP;
    next_time := next_time + interval;
    put_line("==<1-second delay start>== (exactly " & Duration'Image(next_time - clock) &") at" & PutMyTime); 
    delay next_time - clock;
    put_line("===<1-second delay end>=== at " & PutMyTime); 
    put_line("----------- Main LOOP ends at " & PutMyTime);  
  end loop;
  FOR I IN T'RANGE LOOP
    T(I).SHUTDOWN;
  END LOOP;
  put(PutMyTime);
end tasking;
